package gregapi.item;

import static gregapi.data.CS.W;
import gregapi.GT_API;
import gregapi.data.CS.ModIDs;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.lang.LanguageHandler;
import gregapi.log.GT_Log;
import gregapi.old.ToolDictNames;
import gregapi.recipes.GT_ModHandler;

import java.util.List;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public class ItemIntegratedCircuit extends ItemBase {
	public ItemIntegratedCircuit(String aUnlocalized, String aEnglish) {
		super(ModIDs.API, aUnlocalized, aEnglish, "");
		setHasSubtypes(true);
        setMaxDamage(0);
        
		// TODO:
		GT_ModHandler.addShapelessCraftingRecipe(new ItemStack(this, 1, 0), GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {OP.circuit.dat(MT.Basic), ToolDictNames.craftingToolScrewdriver/*, ToolDictNames.craftingToolSolderingIron, ToolDictNames.craftingToolSolderingMetal*/});
		
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 1), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"d  ", " P ", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 2), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {" d ", " P ", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 3), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  d", " P ", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 4), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", " Pd", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 5), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", " P ", "  d", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 6), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", " P ", " d ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 7), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", " P ", "d  ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 8), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", "dP ", "   ", 'P', new ItemStack(this, 1, W)});
		
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1, 9), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"P d", "   ", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,10), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"P  ", "  d", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,11), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"P  ", "   ", "  d", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,12), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"P  ", "   ", " d ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,13), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  P", "   ", "  d", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,14), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  P", "   ", " d ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,15), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  P", "   ", "d  ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,16), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  P", "d  ", "   ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,17), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", "   ", "d P", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,18), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", "d  ", "  P", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,19), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"d  ", "   ", "  P", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,20), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {" d ", "   ", "  P", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,21), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"d  ", "   ", "P  ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,22), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {" d ", "   ", "P  ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,23), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"  d", "   ", "P  ", 'P', new ItemStack(this, 1, W)});
		GT_ModHandler.addCraftingRecipe(new ItemStack(this, 1,24), GT_ModHandler.RecipeBits.BUFFERED | GT_ModHandler.RecipeBits.NOT_REMOVABLE, new Object[] {"   ", "  d", "P  ", 'P', new ItemStack(this, 1, W)});
	}
	
	@Override
	public void addAdditionalToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		super.addAdditionalToolTips(aList, aStack, aF3_H);
		aList.add(LanguageHandler.get(getUnlocalizedName() + ".configuration", "Configuration: ") + getConfigurationString(getDamage(aStack)));
    }
	
	@Override
	public String getUnlocalizedName(ItemStack aStack) {
		return getUnlocalizedName();
	}
	
	@Override
    @SideOnly(Side.CLIENT)
    public final void getSubItems(Item var1, CreativeTabs aCreativeTab, List aList) {
        aList.add(new ItemStack(this, 1, 0));
    }
	
	@Override
    @SideOnly(Side.CLIENT)
    public void registerIcons(IIconRegister aIconRegister) {
		super.registerIcons(aIconRegister);
		// Useful hack to register Item Icons. That is why the Integrated Circuit Item has to exist always.
		if (GT_API.sGTPhaseFinishedPostLoad) {
			GT_Log.out.println("GT_Mod: Setting up Icon Register for Items");
			GT_API.sItemIcons = aIconRegister;
			GT_Log.out.println("GT_Mod: Starting Item Icon Load Phase");
	    	for (Runnable tRunnable : GT_API.sItemIconload) {
	    		try {
	    			tRunnable.run();
	    		} catch(Throwable e) {
	    			e.printStackTrace(GT_Log.err);
	    		}
	    	}
			GT_Log.out.println("GT_Mod: Finished Item Icon Load Phase");
		}
    }
	
	private static String getModeString(int aMetaData) {
		switch ((byte)(aMetaData >>> 8)) {
		case  0: return "==";
		case  1: return "<=";
		case  2: return ">=";
		case  3: return "<";
		case  4: return ">";
		default: return "";
		}
	}
	
	private static String getConfigurationString(int aMetaData) {
		return getModeString(aMetaData) + " " + (byte)(aMetaData & 255);
	}
}