package gregapi.render;

import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
public interface IRenderedBlockObject {
	/** @return the Textures rendered by {@link RendererBlockTextured} */
    @SideOnly(Side.CLIENT)
	public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide);
	
	/** sets the Block Size rendered by {@link RendererBlockTextured} return false for letting it select the normal Block Bounds. */
    @SideOnly(Side.CLIENT)
	public boolean setBlockBounds(Block aBlock, int aRenderPass);
    
    /** gets the Amount of Render Passes for this TileEntity or similar Handler. Only gets called once per Rendering. */
    @SideOnly(Side.CLIENT)
    public int getRenderPasses(Block aBlock);
    
    /** returning true stops all the other Rendering from happening. */
    @SideOnly(Side.CLIENT)
    public boolean renderItem(Block aBlock, RenderBlocks aRenderer);
    
    /** returning true stops all the other Rendering from happening. */
    @SideOnly(Side.CLIENT)
    public boolean renderBlock(Block aBlock, RenderBlocks aRenderer);
}