package gregapi.tileentity;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.ToolsGT;
import gregapi.network.INetworkHandler;
import gregapi.network.IPacket;
import gregapi.util.UT;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraftforge.client.event.DrawBlockHighlightEvent;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.common.Optional;

@Optional.InterfaceList(value = {
	@Optional.Interface(iface = "ic2.api.tile.IWrenchable", modid = ModIDs.IC2)
})
public abstract class TileEntityBase6Directional extends TileEntityBase6Color implements ITileEntityOnDrawBlockHighlight, ic2.api.tile.IWrenchable {
	@Override
    public boolean onDrawBlockHighlight(DrawBlockHighlightEvent aEvent) {
		if (isOverlayingFacingTool(aEvent.currentItem)) {
			try {
				Class.forName("codechicken.lib.vec.Rotation");
				GL11.glPushMatrix();
				GL11.glTranslated(-(aEvent.player.lastTickPosX + (aEvent.player.posX - aEvent.player.lastTickPosX) * aEvent.partialTicks), -(aEvent.player.lastTickPosY + (aEvent.player.posY - aEvent.player.lastTickPosY) * aEvent.partialTicks), -(aEvent.player.lastTickPosZ + (aEvent.player.posZ - aEvent.player.lastTickPosZ) * aEvent.partialTicks));
				GL11.glTranslated(aEvent.target.blockX + 0.5, aEvent.target.blockY + 0.5, aEvent.target.blockZ + 0.5);
				codechicken.lib.vec.Rotation.sideRotations[aEvent.target.sideHit].glApply();
				GL11.glTranslated(0, -0.501, 0);
				GL11.glLineWidth(2.0F);
				GL11.glColor4d(0, 0, 0, 0.5);
				GL11.glBegin(GL11.GL_LINES);
				GL11.glVertex3d( 0.50, 0, -0.25);
				GL11.glVertex3d(-0.50, 0, -0.25);
				GL11.glVertex3d( 0.50, 0,  0.25);
				GL11.glVertex3d(-0.50, 0,  0.25);
				GL11.glVertex3d( 0.25, 0, -0.50);
				GL11.glVertex3d( 0.25, 0,  0.50);
				GL11.glVertex3d(-0.25, 0, -0.50);
				GL11.glVertex3d(-0.25, 0,  0.50);
				GL11.glEnd();
				GL11.glPopMatrix();
			} catch(Throwable e) {/**/}
			return T;
		}
		return F;
	}
	
	@Override
	public IPacket getClientDataPacket(boolean aSendAll) {
		return aSendAll ? getClientDataPacketByteArray(aSendAll, (byte)UT.Code.getR(mRGBa), (byte)UT.Code.getG(mRGBa), (byte)UT.Code.getB(mRGBa), getVisualData(), getDirectionData()) : getClientDataPacketByte(aSendAll, getVisualData());
	}
	
	@Override
	public boolean receiveDataByteArray(byte[] aData, INetworkHandler aNetworkHandler) {
		mRGBa = UT.Code.getRGBInt(new short[] {UT.Code.unsignB(aData[0]), UT.Code.unsignB(aData[1]), UT.Code.unsignB(aData[2])});
		setVisualData(aData[3]);
		setDirectionData(aData[4]);
		return T;
	}
	
	// Stuff to Override
	public byte getDirectionData() {return 0;}
	public void setDirectionData(byte aData) {/**/}
	public boolean isOverlayingFacingTool(ItemStack aStack) {return ToolsGT.contains(getOverlayingFacingTool(), aStack);}
	public String getOverlayingFacingTool() {return "";}
	
	@Override public boolean wrenchCanRemove(EntityPlayer aPlayer) {return F;}
	@Override public float getWrenchDropRate() {return 1.0F;}
	@Override public ItemStack getWrenchDrop(EntityPlayer aPlayer) {return null;}
}