package gregapi.tileentity;

import static gregapi.data.CS.*;
import gregapi.data.CS.ToolsGT;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.World;

public abstract class TileEntityBase6FacingDouble extends TileEntityBase6Facing {
	protected byte mSecondFacing = getDefaultSecondSide();
	
    @Override
	public void readFromNBT2(NBTTagCompound aNBT) {
    	super.readFromNBT2(aNBT);
        if (aNBT.hasKey(NBT_FACING + ".2nd")) mSecondFacing = aNBT.getByte(NBT_FACING + ".2nd");
    }
    
    @Override
	public void writeToNBT2(NBTTagCompound aNBT) {
    	super.writeToNBT2(aNBT);
    	aNBT.setByte(NBT_FACING + ".2nd", mSecondFacing);
    }
    
	@Override
	public long onToolClick2(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (worldObj.isRemote) return 0;
		if (aTool.equals(getOverlayingFacingTool())) {
			byte aTargetSide = UT.Code.getSideWrenching(aSide, aHitX, aHitY, aHitZ);
			if (getValidSides()[aTargetSide]) {
				mFacing = aTargetSide;
				if (!getValidSecondSides()[mSecondFacing]) {
					mSecondFacing = OPPOSITES[mFacing];
					if (!getValidSecondSides()[mSecondFacing]) for (byte tSide : ALL_SIDES_VALID) {
						mSecondFacing = tSide;
						if (getValidSecondSides()[mSecondFacing]) break;
					}
				}
				updateClientData();
				causeBlockUpdate();
				onFacingChange();
				return 10000;
			}
		}
		if (aTool.equals(TOOL_monkeywrench)) {
			byte aTargetSide = UT.Code.getSideWrenching(aSide, aHitX, aHitY, aHitZ);
			if (getValidSecondSides()[aTargetSide]) {
				mSecondFacing = aTargetSide;
				updateClientData();
				causeBlockUpdate();
				onFacingChange();
				return 10000;
			}
		}
		return 0;
	}
	
	@Override
	public boolean onPlaced(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, byte aSide, float aHitX, float aHitY, float aHitZ) {
		mFacing			= (useInversePlacementRotation()?UT.Code.getOppositeSideForPlayerPlacing	(aPlayer, mFacing		, getValidSides			()):UT.Code.getSideForPlayerPlacing			(aPlayer, mFacing		, getValidSides			()));
		mSecondFacing	= (useInversePlacementRotation()?UT.Code.getSideForPlayerPlacing			(aPlayer, mSecondFacing	, getValidSecondSides	()):UT.Code.getOppositeSideForPlayerPlacing	(aPlayer, mSecondFacing	, getValidSecondSides	()));
		onFacingChange();
		return T;
	}
	
	@Override public byte getDirectionData() {return (byte)(mFacing | (mSecondFacing << 3));}
	@Override public void setDirectionData(byte aData) {mFacing = (byte)(aData & 7); mSecondFacing = (byte)((aData >>> 3) & 7);}
	@Override public boolean isOverlayingFacingTool(ItemStack aStack) {return super.isOverlayingFacingTool(aStack) || ToolsGT.contains(TOOL_monkeywrench, aStack);}
	
	// Stuff to Override
	public byte getDefaultSecondSide() {return OPPOSITES[getDefaultSide()];}
	public boolean[] getValidSecondSides() {return getValidSides();}
}